/*
 * availUID - ermittele freie UID im Bereich MIN_UID - MAX_UID
 * Dirk Schiller, Apr 1994
 * uebersetzen mit: cc -o availUID availUID.c
 */
 
#include <stdio.h>
#include <stdlib.h>
#include <pwd.h>

#define MIN_UID	200
#define MAX_UID	499

int qucmp_uid(left, right)
	uid_t *left, *right;
{
	return(*left - *right);
}

main()
{
	int 	i, erfolg, count;
	struct	passwd	*p;
	uid_t	uidtab[MAX_UID - MIN_UID +1];

	count = 0;
	while ((p = getpwent()) != NULL) {
		if ((p->pw_uid >= MIN_UID) && (p->pw_uid <= 
MAX_UID)) {
			uidtab[count]=p->pw_uid;
			count++;
		}
	}
	endpwent();

	if (count == 0) {
		printf("%d\n",MIN_UID);
		exit(0);
	}
                                	
	qsort(uidtab, count-1, sizeof(uid_t), qucmp_uid);

	i=0; erfolg=0;
	while ((!erfolg) && (i<count)) {
		erfolg=(uidtab[i+1] > uidtab[i]+1);
		i++;
	}
	if ((erfolg) || (uidtab[i-1]<MAX_UID)) { 
		printf("%d\n",uidtab[i-1]+1);
		exit(0);
	}
	else {	
		printf("Keine freie UID zwischen %d und %d 
gefunden!\n",MIN_UID, MAX_UID);
		exit(1);
	}
}

